require(['config'], function() {
	require([
	], function($) {
		mobPageObj.init();
	});
});

/*API URL*/
const API_MOBILE_GRID_LIST 			= '/api/loan/state/detail-grid-list';	// 목록
const API_MOBILE_INFO 				= '/api/loan/state/info-loan-mng';		// 상세
const API_MOBILE_HISTORY			= '/api/loan/state/hist-grid-list';		// 이력
const API_POP_SEARCH_LIST			= '/api/store/pop-grid-list';

const PAGE_MODE_LIST				= "LIST";
const PAGE_MODE_VIEW				= "VIEW";

let mobPageObj = {
	viewMode: PAGE_MODE_LIST,
	init: function () {
		this.ui.init();
		this.event.init();
		this.ready();
	},
	ui: {
		init: function () {
			this.view();
			this.info();
		},
		view: function() {
			// 공통코드 표시
			$('select').each(function() {
				if($(this).data('select-code')) {
					fn_make_select(CODE_LIST, $(this).data('select-code'), $(this).attr('id'));
				}
			});
		},
		info: function() {
			$('input:hidden[id$="_BRAND_ID"]').val(fn_make_user_info.get('brandId'));
			$('input:hidden[id$="_STORE_ID"]').val(fn_make_user_info.get('storeId'));
		}
	},
	event: {
		init: function() {
			this.button();
		},
		button: function() {
			$('button[id^="ITP_BTN_MLOANMNG01010_LIST"]').on('click', function() {
				var id = $(this).attr('id');
				switch (id) {
					case 'ITP_BTN_MLOANMNG01010_LIST_SEARCH_STORE_NM'	: mobPopObj.popStoreNm.init(); 		break;
					case 'ITP_BTN_MLOANMNG01010_LIST_DELETE_STORE_NM'	: mobPopObj.popStoreNm.delete(); 	break;
					case 'ITP_BTN_MLOANMNG01010_LIST_SEARCH'			: mobContObj.list.search();		break;
				}
				return false;
			});

			$('button[id^="ITP_BTN_MLOANMNG01010_VIEW"]').on('click', function() {
				var id = $(this).attr('id');
				switch (id) {
					case 'ITP_BTN_MLOANMNG01010_VIEW_SEARCH'		: mobContObj.view.history.search();	break;
					case 'ITP_BTN_MLOANMNG01010_VIEW_CANCEL_LIST'	: mobContObj.view.cancel();			break;
				}
				return false;
			});

			$(document).on('click', '#ITP_LIST_MLOANMNG01010_LIST_ITEM_ROWS li', function() {
				var item = mobContObj.list.rows[$(this).index()];
				mobContObj.view.init(item);
			});

			$(document).on('click', '#ITP_LIST_MLOANMNG01010_POP_STORE_ROWS li button', function() {
				mobPopObj.popWhsNm.choice($(this));
			});
		}
	},
	switchScreen: function(mode) {
		$('#ITP_MOBILE_MLOANMNG01010').find('div[id$="_CONTAINER"]').each(function(i) {
			$(this).hide();
		});
		if(mode === PAGE_MODE_LIST) {
			$('#ITP_AJAX_MLOANMNG01010_LIST_CONTAINER').show();
			CommonObj.moreView('#ITP_LIST_MLOANMNG01010_VIEW_ITEM_AREA', false);
		} else if(mode === PAGE_MODE_VIEW) {
			$('#ITP_AJAX_MLOANMNG01010_VIEW_CONTAINER').show();
			CommonObj.moreView('#ITP_LIST_MLOANMNG01010_LIST_ITEM_AREA', false);
		}
		this.viewMode = mode;
	},
	ready: function() {
		mobContObj.list.init();
	}
};

let mobContObj = {
	list: {
		listPage: 1,
		rows: [],
		init: function() {
			mobPageObj.switchScreen(PAGE_MODE_LIST);
			this.search();
		},
		search: function() {
			this.listPage = 1;
			this.rows.length = 0;
			$('#ITP_LIST_MLOANMNG01010_LIST_ITEM_ROWS').empty();
			setTimeout(function() {
				mobContObj.list.load();
			}, 100);
		},
		pager: function(totPage) {
			(this.listPage < totPage) ?
				CommonObj.moreView('#ITP_LIST_MLOANMNG01010_LIST_ITEM_AREA', true, mobContObj.list.load) :
				CommonObj.moreView('#ITP_LIST_MLOANMNG01010_LIST_ITEM_AREA', false);
			this.listPage += 1;
		},
		load: function() {
			var _this = this;
			var callbackFn = function(result) {
				console.log(result);
				mobContObj.list.pager(result.gridTotal);
				$.each(result.gridRows, function (i, item) {
					$('#ITP_LIST_MLOANMNG01010_LIST_ITEM_AREA .panel-group').append($('#ITP_LIST_MLOANMNG01010_LIST_ITEM_ROWCOPY').html());
					var $li = $('#ITP_LIST_MLOANMNG01010_LIST_ITEM_AREA .panel-group > .item-row:last');
					$li.find('.fnStoreNm').text(item.storeNm);
					$li.find('.fnLoanDvsnNm').text(item.loanDvsnNm);
					$li.find('.fnLimitAmt').text(CommonObj.currency.add(item.limitAmt));
					$li.find('.fnPosbLimitAmt').text(CommonObj.currency.add(item.posbLimitAmt));
					$li.find('.fnTmpRcvAcctTotal').text(CommonObj.currency.add(item.tmpRcvAcctTotal));
					$li.find('.fnUseAmtTotal').text(CommonObj.currency.add(item.useAmtTotal));
					$li.find('.fnUseYnNm').text(item.useYnNm);
					mobContObj.list.rows.push(item);
				});
			};
			const param = $('#ITP_FORM_MLOANMNG01010_LIST_SEARCH').serializeObject();
			param.gridPage = mobContObj.list.listPage;
			param.gridSize = mobile_list_size;
			fn_ajax_call(API_MOBILE_GRID_LIST, JSON.stringify(param), callbackFn, 'POST');
		}
	},
	view: {
		init: function(item) {
			mobPageObj.switchScreen(PAGE_MODE_VIEW);
			this.search(item);
		},
		search: function(item) {
			var _this = this;
			var callbackFn = function(result) {
				console.log(result);
				_this.view(result);
			};
			const param = {
				'brandId': fn_make_user_info.get('brandId'),
				'spplyId': fn_make_user_info.get('spplyId'),
				'loanMgntUnqNo': item.loanMgntUnqNo
			};
			fn_ajax_call(API_MOBILE_INFO, param, callbackFn, 'GET');
		},
		view: function(result) {
			var _this = this;
			var id = '#ITP_AJAX_MLOANMNG01010_VIEW_CONTAINER';
			$(id).find('.fnStoreNm').text(result.storeNm);
			$(id).find('.fnLoanDvsnNm').text(result.loanDvsnNm);
			var limitAmt;
			if(result.loanDvsn == 'LD01') { // 선불(충전)
				limitAmt = result.chrgeLimitAmt;
			} else if(result.loanDvsn == 'LD02') { // 후불(신용)
				limitAmt = result.credtLimitAmt;
			}
			$(id).find('.fnLimitAmt').text(CommonObj.currency.add(limitAmt));
			$(id).find('.fnUseYnNm').text(result.useYnNm);
			$(id).find('.fnPosbLimitAmt').text(CommonObj.currency.add(limitAmt + result.acctBal - result.useAmtTotal));
			$(id).find('.fnTmpRcvAcctTotal').text(CommonObj.currency.add(result.acctBal));
			$(id).find('.fnUseAmtTotal').text(CommonObj.currency.add(result.useAmtTotal));
			_this.history.init(result.loanMgntUnqNo);
		},
		history: {
			rows: [],
			listPage: 1,
			init: function(loanMgntUnqNo) {
				// 조회일자 지정
				$('#ITP_MOBILE_MLOANMNG01010 .itp_input.date').datepicker(ITP_DATE_LANGUAGE);
				$('#ITP_FORM_MLOANMNG01010_VIEW_SEARCH_FROM_DT').datepicker('setDate', itp_fn_date_add('M', -1));
				$('#ITP_FORM_MLOANMNG01010_VIEW_SEARCH_TO_DT').datepicker('setDate', itp_fn_date_add('M', 0));
				this.loanMgntUnqNo = loanMgntUnqNo;
				this.search();
			},
			search: function() {
				this.listPage = 1;
				this.rows.length = 0;
				$('#ITP_LIST_MLOANMNG01010_VIEW_ITEM_ROWS').empty();
				setTimeout(function() {
					mobContObj.view.history.load();
				}, 100);
			},
			pager: function(totPage) {
				(this.listPage < totPage) ?
					CommonObj.moreView('#ITP_LIST_MLOANMNG01010_VIEW_ITEM_AREA', true, mobContObj.view.history.load) :
					CommonObj.moreView('#ITP_LIST_MLOANMNG01010_VIEW_ITEM_AREA', false);
				this.listPage += 1;
			},
			load: function() {
				var _this = this;
				var callbackFn = function(result) {
					console.log(result);
					mobContObj.view.history.pager(result.gridTotal);
					$.each(result.gridRows, function (i, item) {
						$('#ITP_LIST_MLOANMNG01010_VIEW_ITEM_AREA .panel-group').append($('#ITP_LIST_MLOANMNG01010_VIEW_ITEM_ROWCOPY').html());
						var $li = $('#ITP_LIST_MLOANMNG01010_VIEW_ITEM_AREA .panel-group > .item-row:last');
						$li.find('.fnLoanRegDt').text(item.loanRegDt);
						$li.find('.fnDpstPayDvsnNm').text(item.dpstPayDvsnNm);
						$li.find('.fnPaymAmt').text(CommonObj.currency.add(CommonObj.nullToString(item.dpstPayDvsn === 'D' ? item.dpstAmt : item.paymAmt)));
						$li.find('.fnTrscAfBal').text(CommonObj.currency.add(item.trscAfBal));
						$li.find('.fnUse').text(item.use);
						mobContObj.view.history.rows.push(item);
					});
				};
				const param = $('#ITP_FORM_MLOANMNG01010_VIEW_SEARCH').serializeObject();
				param.gridPage = mobContObj.view.history.listPage;
				param.gridSize = mobile_list_size;
				param.sloanMgntUnqNo = _this.loanMgntUnqNo;
				console.log(JSON.stringify(param));
				fn_ajax_call(API_MOBILE_HISTORY, JSON.stringify(param), callbackFn, 'POST');
			}
		},
		cancel: function () {
			var id = '#ITP_AJAX_MLOANMNG01010_VIEW_CONTAINER';
			$(id).find('.fnItemid').text('');
			$(id).find('.fnItemNm').text('');
			$(id).find('.fnUPodrQty').text('');
			$(id).find('.fnUnitAmt').text('');
			$(id).find('.fnUnit').text('');
			$(id).find('.fnPodrQty').text('');
			$(id).find('.fnPodrAmt').text('');
			$(id).find('.fnDlvReqDt').text('');
			$('#ITP_LIST_MLOANMNG01010_VIEW_ITEM_AREA .panel-group').empty();
			mobPageObj.switchScreen(PAGE_MODE_LIST);
		}
	}
};

let mobPopObj = {
	popStoreNm: {
		popId: 'ITP_POP_MLOANMNG01010_STORE_AREA',
		rows: [],
		init: function () {
			this.rows.length = 0;
			mobPopObj.show(this.popId);
			this.search();
			this.action();
		},
		search: function () {
			var _this = this;
			$('#ITP_LIST_MLOANMNG01010_POP_STORE_AREA .panel-group').empty();
			var callbackFn = function(result) {
				console.log(result);
				_this.view(result.gridRows);
			};
			const param = $('#ITP_FORM_MLOANMNG01010_POP_STORE').serializeObject();
			fn_ajax_call(API_POP_SEARCH_LIST, JSON.stringify(param), callbackFn, 'POST');
		},
		view: function(gridRows) {
			this.rows = gridRows;
			$.each(gridRows, function (i, item) {
				$('#ITP_LIST_MLOANMNG01010_POP_STORE_AREA .panel-group').append($('#ITP_LIST_MLOANMNG01010_POP_STORE_ROWCOPY').html());
				var $li = $('#ITP_LIST_MLOANMNG01010_POP_STORE_AREA .panel-group > .row_2:last');
				$li.find('.fnStoreNm').text(item.storeNm);
				$li.find('.fnStoreStNm').text(item.storeStNm);
				$li.find('.fnStoreId').data('store-id', item.storeId);
			});
		},
		choice: function(elem) {
			var _this = this;
			var storeId = $(elem).data('store-id');
			$.each(this.rows, function (i, item) {
				if(storeId === item.storeId) {
					$('#ITP_FORM_MLOANMNG01010_LIST_SEARCH #ITP_FORM_MLOANMNG01010_LIST_SEARCH_STORE_ID').val(item.storeId);
					$('#ITP_FORM_MLOANMNG01010_LIST_SEARCH #ITP_FORM_MLOANMNG01010_LIST_SEARCH_STORE_NM').val(item.storeNm);
					_this.close();
					return false;
				}
			});
		},
		action: function() {
			var _this = this;
			$('button[id^="ITP_BTN_MLOANMNG01010_POP_STORE"]').off('click').on('click', function() {
				var id = $(this).attr('id');
				switch (id) {
					case 'ITP_BTN_MLOANMNG01010_POP_STORE_SEARCH'	: _this.search();			break;
					case 'ITP_BTN_MLOANMNG01010_POP_STORE_CHOICE'	: _this.choice($(this)); 	break;
					case 'ITP_BTN_MLOANMNG01010_POP_STORE_CLOSE'	: _this.close(); 			break;
				}
				return false;
			});
		},
		delete: function() {
			$('#ITP_FORM_MLOANMNG01010_LIST_SEARCH #ITP_FORM_MLOANMNG01010_LIST_SEARCH_STORE_ID').val('');
			$('#ITP_FORM_MLOANMNG01010_LIST_SEARCH #ITP_FORM_MLOANMNG01010_LIST_SEARCH_STORE_NM').val('');
		},
		close: function() {
			this.rows.length = 0;
			$('#ITP_POP_MLOANMNG01010_LIST_WHS_AREA .panel-group').empty();
			$('#ITP_FORM_MLOANMNG01010_POP_STORE #ITP_FORM_MLOANMNG01010_POP_STORE_KEYWORD').val('');
			mobPopObj.hide(this.popId);
		}
	},
	show: function(popId) {
		$('button[id$="_CLOSE"]').off('click').on('click', function() {
			console.log($(this).attr('id'));
			if($(this).hasClass('btn-pop-close')) {
				mobPopObj.hide(popId);
			}
		});
		$('#' + popId).show();
	},
	hide: function(popId) {
		$('#' + popId).closest('.mobile-pop-close').hide();
	}
};
